<template>
  <div>
    <mt-page-title
      :with-border="false"
      :with-padding="false"
      border-style="padding:1.5rem 0"
      link-text="retour aux groupes"
      :link-to="profilLink({ name: 'pax-groupe' })"
    >
      <h1 class="has-text-weight-bold is-size-3">
        Créer un groupe
      </h1>
    </mt-page-title>
    <mt-form-groupe
      :utilisateurs-selected="utilisateursSelected"
      :groupe="groupe"
      :utilisateurs="utilisateurs"
      :id-corps="idCorps"
      :autocomplete-data="data"
      :is-fetching="isFetching"
      @submit="creerGroupe"
      @select-all="viderFiltre"
      @select-categorie="filtreCategorie"
      @typing="getAsyncData"
      @select="selectAutoComplete"
      @ajouter="ajouter"
      @delete="supprimer"
      @selectionner-all-user="selectionnerAll"
    >
      <div class="control">
        <nuxt-link
          :to="profilLink({ name: 'pax-groupe' })"
          class="button is-secondary mt-button is-size-8 has-text-weight-semibold"
        >
          annuler
        </nuxt-link>
      </div>
      <div class="control">
        <b-button
          class="mt-button is-size-8 has-text-weight-semibold"
          type="is-primary"
          native-type="submit"
          :disabled="!groupe.nom"
        >
          Créer un groupe
        </b-button>
      </div>
    </mt-form-groupe>
    <mt-modal-ok :ouvert.sync="ouvert" @action="retourGroupe">
      Le groupe a bien été créé.
    </mt-modal-ok>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtModalOk from '~/components/modal/mt-modal-ok';
import userMixin from '~/components/mixins/userMixin';
import { newGroupePersonnaliser, groupePersonnaliserMixin } from '~/components/mixins/groupePersonnaliserMixin';
import MtFormGroupe from '~/components/pax/groupe/form-groupe';

export default {
  layout: 'container-small',
  components: {
    MtFormGroupe,
    MtPageTitle,
    MtModalOk,
  },
  mixins: [userMixin, groupePersonnaliserMixin],
  data() {
    return {
      groupe: newGroupePersonnaliser(),
      utilisateursSelected: [],
    };
  },
  async asyncData({ $api }) {
    const utilisateurs = await $api.organisme().utilisateursFilter();
    return {
      utilisateurs,
    };
  },
  methods: {
    async creerGroupe() {
      try {
        this.groupe.proprietaire = this.utilisateur;
        this.utilisateursSelected.forEach((utilisateur) => {
          this.groupe.groupesPersonnaliserDetails.push({ utilisateur });
        });
        await this.$api.groupePersonnaliser.post(this.groupe);
        this.ouvert = true;
      } catch ({ response: { status }, data: { message } }) {
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/deep/ .mt-list-item {
  display: flex;
  align-items: center;
}

.mt-nom-prenom {
  flex-grow: 1;
}

/deep/ .mt-filter-liste {
  & > article {
    margin-left: 0.75em;
  }
}
.margin {
  margin: 1rem 0;
}
.is-selected {
  color: #dfdfdf;

  &.mt-list-item-selected {
    color: $soft-blue;
  }
}
</style>
